Bug 742388 - Review Request: polybori - Framework for Boolean Rings
Summary: Review Request: polybori - Framework for Boolean Rings
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Brendan Jones
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-09-29 22:08 UTC by Jerry James
Modified: 2012-01-03 15:57 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-01-03 15:57:45 UTC
Type: ---
brendan.jones.it: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jerry James 2011-09-29 22:08:11 UTC
Spec URL: http://jjames.fedorapeople.org/polybori/polybori.spec
SRPM URL: http://jjames.fedorapeople.org/polybori/polybori-0.8.0-1.fc15.src.rpm
Description: PolyBoRi is a special purpose computer algebra system for computations in Boolean Rings.  The core is a C++ library, which provides high-level data types for Boolean polynomials and related structures.  As a unique approach, binary decision diagrams are used as internal storage type for polynomial structures.  On top of this, we provide a Python interface for parsing of complex polynomial systems, as well as for sophisticated and extendable strategies for Gröbner base computation.

This is a re-review for a name change.  The original package name is python-polybori.  The reason for the rename is that this package provides both C++ and python interfaces, and the new package structure enables consumers of the C++ interface to avoid pulling in python dependencies.

Comment 1 Thomas Spura 2011-09-30 13:16:06 UTC
The __provides_exclude_from shouldn't be used anymore use this:
https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Arch-specific_extensions_to_scripting_languages

Comment 2 Jerry James 2011-09-30 19:47:12 UTC
(In reply to comment #1)
> The __provides_exclude_from shouldn't be used anymore use this:
> https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Arch-specific_extensions_to_scripting_languages

No, the filtering method described there CANNOT be used for this package:

https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Usage

The __provides_exclude_from method is new with RPM 4.9, and does not suffer from those usage restrictions.  See:

http://fedoraproject.org/wiki/User:Tibbs/AutoProvidesAndRequiresFiltering#RPM_4.9_method_.28Fedora_15_and_newer.29

Comment 3 Thomas Spura 2011-10-06 21:08:41 UTC
(In reply to comment #2)
> (In reply to comment #1)
> > The __provides_exclude_from shouldn't be used anymore use this:
> > https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Arch-specific_extensions_to_scripting_languages
> 
> No, the filtering method described there CANNOT be used for this package:
> 
> https://fedoraproject.org/wiki/Packaging:AutoProvidesAndRequiresFiltering#Usage
> 
> The __provides_exclude_from method is new with RPM 4.9, and does not suffer
> from those usage restrictions.  See:
> 
> http://fedoraproject.org/wiki/User:Tibbs/AutoProvidesAndRequiresFiltering#RPM_4.9_method_.28Fedora_15_and_newer.29

Thanks for that link, that's news to me...
On the same page is "You must use %define" for it, currently it's %global.

I don't understand bug #652971 comment#41.
Looks like the macros have been replaced and are ok now?

Comment 4 Jerry James 2011-10-07 14:01:06 UTC
(In reply to comment #3)
> Thanks for that link, that's news to me...
> On the same page is "You must use %define" for it, currently it's %global.

Yeah, that should read "You must use %define or %global", as opposed to using %filter_setup.  See https://fedorahosted.org/fpc/ticket/76.

> I don't understand bug #652971 comment#41.
> Looks like the macros have been replaced and are ok now?

Hmmm, I don't understand that comment either.  All I know is that I get the right result with this filter expression.

Comment 5 Jerry James 2011-10-14 21:50:43 UTC
A problem with building the existing python-polybori package on secondary arches was discovered and patched by Dan Horák.  I have updated this package to have the same fix, but did not bump the release number.  The URLs have not changed.

Comment 6 Brendan Jones 2011-12-22 11:42:32 UTC
I will take this review.

Comment 7 Brendan Jones 2011-12-22 13:36:53 UTC
Hi Jerry,

I get rpmlint errors in polybori.x86_64: E: no-binary

Ordinarily this means that this package should be BuildArch: noarch, but after looking at the script you can see its a wrapper for the ipython script.

This highlights something that needs changing I think, namely that we have an architecture specific script in /usr/share (which is not permitted)

I haven't tried it but I'd suggest you move the script to /usr/bin where it belongs and provide a simple patch such that it looks for what it needs in /usr/share/polybori 


rpm -qlpv /home/bsjones/rpmbuild/RPMS/x86_64/polybori-0.8.0-1.fc16.x86_64.rpm
lrwxrwxrwx    1 root    root                       31 Dec 22 14:09 /usr/bin/ipbori -> ../share/polybori/ipbori/ipbori
-rw-r--r--    1 root    root                     1337 Sep  7 22:25 /usr/share/man/man1/ipbori.1.gz
drwxr-xr-x    2 root    root                        0 Dec 22 14:09 /usr/share/polybori
drwxr-xr-x    2 root    root                        0 Dec 22 14:09 /usr/share/polybori/ipbori
-rwxr-xr-x    1 root    root                     2003 Dec 22 14:09 /usr/share/polybori/ipbori/ipbori
-rw-r--r--    1 root    root                     1162 Dec 22 14:09 /usr/share/polybori/ipbori/ipythonrc-polybori

Comment 8 Jerry James 2011-12-23 00:25:30 UTC
I'm not sure I understand.  What script is architecture specific?

In any case, I moved the ipbori script to %{_bindir} as requested, but rpmlint is still going to give that error, since there is no binary in the main package.  I"m willing to discuss other ways of dividing the subpackages if you don't like this arrangement.

Spec URL: http://jjames.fedorapeople.org/polybori/polybori.spec
SRPM URL: http://jjames.fedorapeople.org/polybori/polybori-0.8.0-2.fc16.src.rpm

Comment 9 Brendan Jones 2011-12-23 01:04:47 UTC
Sorry I should have been more specific:

fedora16:~ $ grep lib64 /usr/share/polybori/ipbori/ipbori
# Note: ../../lib64/python2.7/site-packages is replaced on installation with relative path 
export IPBORI_INIT_CMDS="import sys; sys.path.insert(0, '$PBDIR/../../lib64/python2.7/site-packages');\

There you can see hard coded references to lib64. 

On looking at this, I've also noticed that if you install only polybori and polybori-libs and try and run this script you get 

Python 2.7.2 (default, Oct 27 2011, 01:40:22) 
Type "copyright", "credits" or "license" for more information.

IPython 0.11 -- An enhanced Interactive Python.
?         -> Introduction and overview of IPython's features.
%quickref -> Quick reference.
help      -> Python's own help system.
object?   -> Details about 'object', use 'object??' for extra details.

---------------------------------------------------------------------------
ImportError                               Traceback (most recent call last)
/home/bsjones/<ipython-input-1-9b992f309336> in <module>()
----> 1 print'';import sys; sys.path.insert(0, '/usr/share/polybori/../../lib64/python2.7/site-packages');from polybori.frontend import *; polybori_start(globals())

ImportError: No module named polybori.frontend

So I would think that the script needs to be in whatever package  polybori.frontend is in (python-polybori). That doesn't leave much left in the main package so you will need to either add another requires or reconsider the layout of your subpackages.

Comment 10 Jerry James 2011-12-29 19:42:12 UTC
OK, sorry to be dense on the script issue.  You're right: even though rpmlint thinks that script is noarch, it really is arch-specific.  I've rearranged the packages slightly; briefly polybori => polybori-ipbori and polybori-libs => polybori.  I also changed the Requires to reflect the new layout, and the ipbori dependency you noted in comment 9.  I also made polybori-docs be noarch.

Spec URL: http://jjames.fedorapeople.org/polybori/polybori.spec
SRPM URL: http://jjames.fedorapeople.org/polybori/polybori-0.8.0-3.fc16.src.rpm

Comment 11 Brendan Jones 2012-01-02 10:33:33 UTC
Hi Jerry,

Now all good. This package is APPROVED

Required
========
+ - OK
- - N/A
X - attention
? - comment please

[+] named according to the Package Naming Guidelines 
[+] The spec file name must match the base package %{name}, in the format
%{name}.spec 
[+] Meet the Packaging Guidelines
unless building for F12 and below  or EPEL   
[+] Be licensed with a Fedora approved license and meet the Licensing
Guidelines 
[+] The License field in the package spec file must match the actual license 
[+] License file must be included in %doc
[+] The spec file must be written in American English
[+] The spec file for the package MUST be legible
[+] The sources used to build the package must match the upstream source
266218f3ccee05854dac6ea3e68ddbc570c16c45  rpmbuild/SOURCES/polybori-0.8.0.tar.gz
[+] Successfully compile and build into binary rpms on at least one primary
architecture
[-] Proper use of ExcludeArch 
[+] All build dependencies must be listed in BuildRequires
[-] The spec file MUST handle locales properly
[+] Shared library files (not just symlinks) in any of the dynamic linker's
default paths, must call ldconfig in %post and %postun
[+] Packages must NOT bundle copies of system libraries
[-] If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package
[+] A package must own all directories that it creates
directories under this
[+] A Fedora package must not list a file more than once in the spec file's
%files listings
[+] Permissions on files must be set properly.
[+] Each package must consistently use macros
[+] The package must contain code, or permissable content
[+] Large documentation files must go in a -doc subpackage
[+] If a package includes something as %doc, it must not affect the runtime of
the application
[+] Header files must be in a -devel package
[+] Static libraries must be in a -static package
[+] library files that end in .so (without suffix) must go in a -devel package
[+] devel packages must require the base package using a fully versioned
dependency
[+] Packages must NOT contain any .la libtool archives
[+] GUI apps must include a %{name}.desktop file, properly installed with
desktop-file-install in the %install section 
[+] Packages must not own files or directories already owned by other packages
[+] All filenames in rpm packages must be valid UTF-8

[+] Has BuildRequires: python2-devel and/or python3-devel

[-] Python eggs must be built from source. They cannot simply drop an egg from upstream into the proper directory.
[+] Python eggs must not download any dependencies during the build process.
[-] If egg-info files are generated by the modules build scripts they must be included in the package.
[-] When building a compat package, it must install using easy_install -m so it won't conflict with the main package.
[-] When building multiple versions (for a compat package) one of the packages must contain a default version that is usable via "import MODULE" with no prior setup.
[-] A package which is used by another package via an egg interface should provide egg info. 
[+] Requires OK

[-] Egg install:
%install
%{__python} setup.py install --skip-build --root $RPM_BUILD_ROOT 

Should Items
============
[-] the packager SHOULD query upstream for any missing license text files to
include it
[-] Non-English language support for description and summary sections in the
package spec if available
[+] The reviewer should test that the package builds in mock
[+] The package should compile and build into binary rpms on all supported
architectures
[-] The reviewer should test that the package functions as described
[+] If scriptlets are used, those scriptlets must be sane
[+] Usually, subpackages other than devel should require the base package using
a fully versioned dependency
Do you need an explicit Requires: apron-debug in package ocaml-apron-debug?
[-] The placement of pkgconfig(.pc) should usually be placed in a -devel pkg
[-] If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself
[+] Should contain man pages for binaries/scripts

Comment 12 Jerry James 2012-01-03 03:56:20 UTC
New Package SCM Request
=======================
Package Name: polybori
Short Description: Framework for Boolean Rings
Owners: jjames
Branches: 
InitialCC:

Comment 13 Gwyn Ciesla 2012-01-03 13:24:48 UTC
Git done (by process-git-requests).

Brendan, please take ownership of review BZs, thanks!


Note You need to log in before you can comment on or make changes to this bug.